	// verilator_coverage annotation
	// generated by verigenSV.pl on Fri Apr 30 12:49:40 2021
	// input file: ras.cfg
	
	// compiler directives
	/* verilator lint_off CASEINCOMPLETE */
	/* verilator lint_off DECLFILENAME */
	/* verilator lint_off UNUSED */
	/* verilator lint_off STMTDLY */
	/* verilator lint_off UNOPTFLAT */
	
	module RAS (
 000200		input logic clk,
%000003		input logic res_n,
%000003		input logic lock,
%000006		input logic unlock,
%000108		input logic [KEY_WIDTH-1:0] key,
 000055		input logic in_addr_val,
 000141		input logic [RAS_WIDTH-1:0] in_addr,
 000042		input logic rd,
 000028		output logic out_addr_val, 
 000827		output logic [RAS_WIDTH-1:0] out_addr, 
%000005		output logic locked, 
 000036		output logic ras_write_active, 
%000007		output logic empty, 
%000001		output logic full );
	
	  //
	 // parameter constants 
	//---------------------------
	parameter int RAS_SIZE = 16;
	parameter int RAS_WIDTH = 48;
	parameter int KEY_WIDTH = 32;
	parameter logic [KEY_WIDTH-1:0] KEY = 32'hDEADBEEF;
	parameter logic [RAS_WIDTH-1:0] ZERO_ADDR = {RAS_WIDTH{1'b0}}; ;
	
	
	  //
	 // state encoding typedef 
	//--------------------------------
	typedef enum logic [0:0] {
		LOCKED	 = 1'b1,
		UNLOCKED	 = 1'b0
	} states_t;
	
	
	// internal state variables
%000005	states_t STATE, NEXT_STATE;
%000005	verilator_coverage: (next point on previous line)

	
	
	  //
	 // memory instantiations 
	//---------------------------
 000037	logic RAS_STACK_status;
 000200	logic RAS_STACK_clk; 
%000003	logic RAS_STACK_res_n; 
 000037	logic RAS_STACK_wr;
 000134	logic [RAS_WIDTH-1:0] RAS_STACK_wr_data;
 000028	logic RAS_STACK_rd;
 000861	logic [RAS_WIDTH-1:0] RAS_STACK_rd_data;
%000003	logic RAS_STACK_empty;
%000000	logic RAS_STACK_full;
	assign RAS_STACK_clk = clk;
	assign RAS_STACK_res_n = res_n;
	STACK #(RAS_WIDTH,RAS_SIZE) RAS_STACK(
		.clk(RAS_STACK_clk), .res_n(RAS_STACK_res_n), 
		.wr(RAS_STACK_wr), .wr_data(RAS_STACK_wr_data[RAS_WIDTH-1:0]), 
		.rd(RAS_STACK_rd), .rd_data(RAS_STACK_rd_data[RAS_WIDTH-1:0]), 
		.empty(RAS_STACK_empty), .full(RAS_STACK_full) );
	
	
	  //
	 // implicit continuous assignments 
	//----------------------------------
%000008	wire DO_IDLE; assign DO_IDLE = !lock & !unlock;
%000003	wire DO_LOCK ; assign DO_LOCK  =  lock & !unlock ;
 000028	wire DO_READ_STACK; assign DO_READ_STACK = (UNLOCKED==STATE) & rd;
%000005	wire DO_UNLOCK; assign DO_UNLOCK = !lock &  unlock & IS_KEY_MATCH ;
 000041	wire DO_WRITE_STACK; assign DO_WRITE_STACK = (UNLOCKED==STATE) & in_addr_val;
%000004	wire IS_KEY_MATCH; assign IS_KEY_MATCH = (KEY==key);
	wire RAS_STACK_rd_data; assign RAS_STACK_rd_data = READ_RAS_STACK(DO_READ_STACK);
	
	
	  //
	 // initials for simulator
	//---------------------------
%000002	initial begin
%000001	  STATE = LOCKED;
%000001	  RAS_STACK_wr = 1'b0;
%000001	  RAS_STACK_rd = 1'b0;
%000001	  RAS_STACK_wr_data[RAS_WIDTH-1:0] = {RAS_WIDTH{1'b0}};
	
	  // dump output (Verilator)
%000002	  if ($test$plusargs("trace") != 0) begin
%000000	  verilator_coverage: (next point on previous line)

%000001	    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
%000001	    $dumpfile("logs/vlt_dump.vcd");
%000001	    $dumpvars();
	  end
%000001	  $display("[%0t] Model running...\n", $time);
	
	
	end
	
	
	  //
	 // state transfer
	//---------------------------
 000200	always_ff @( posedge clk ) begin
 000194	  if( res_n )
%000003	  verilator_coverage: (next point on previous line)

 000097	    STATE <= NEXT_STATE;
	  else
%000003	    STATE <= LOCKED;
	
	  // condition for $finish (Verilator)
%000002	  if( lock==1'b1 && unlock==1'b1 && in_addr_val==1'b1 && res_n==1'b0 ) begin
 000099	  verilator_coverage: (next point on previous line)

%000001	    $write("*-* All Finished *-*\n");
%000001	    $finish;
	  end   
	
	end
	// AssertionExample:
	//always_ff @ (posedge clk) begin
	//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
	//end
	
	// coverage analysis (Verilator)
	// cover property ( @(posedge clk) rd_q0==1'b1 && rd_q1==1'b1 && res_n==1'b0 );
	
 000470	always_comb begin
 000235	  unique case ( STATE )
 000154	  LOCKED : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
 000150		if ( !DO_UNLOCK ) begin
%000002		verilator_coverage: (next point on previous line)

 000075		  NEXT_STATE = LOCKED;
		  // MEMORY action ...
 000075		  RAS_STACK_status = WRITE_RAS_STACK(DO_WRITE_STACK,in_addr);
		  // MEALY output action ...
 000075		  ras_write_active=1'b0;
 000075		  out_addr_val=1'b0;
 000075		  out_addr=ZERO_ADDR;
 000075		  empty=1'b0;
 000075		  full=1'b0;
 000075		  locked=STATE;
		end
%000004		if ( DO_UNLOCK ) begin
 000075		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = UNLOCKED;
		  // MEMORY action ...
%000002		  RAS_STACK_status = WRITE_RAS_STACK(DO_WRITE_STACK,in_addr);
		  // MEALY output action ...
%000002		  ras_write_active=RAS_STACK_status;
%000002		  out_addr_val=DO_READ_STACK;
%000002		  out_addr=RAS_STACK_rd_data;
%000002		  empty=RAS_STACK_empty;
%000002		  full=RAS_STACK_full;
%000002		  locked=STATE;
		end
	  end // LOCKED
 000316	  UNLOCKED : begin
		// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
 000306		if ( DO_IDLE ) begin
%000005		verilator_coverage: (next point on previous line)

 000153		  NEXT_STATE = UNLOCKED;
		  // MEMORY action ...
 000153		  RAS_STACK_status = WRITE_RAS_STACK(DO_WRITE_STACK,in_addr);
		  // MEALY output action ...
 000153		  ras_write_active=RAS_STACK_status;
 000153		  out_addr_val=DO_READ_STACK;
 000153		  out_addr=RAS_STACK_rd_data;
 000153		  empty=RAS_STACK_empty;
 000153		  full=RAS_STACK_full;
 000153		  locked=STATE;
		end
%000002		if ( DO_LOCK ) begin
 000157		verilator_coverage: (next point on previous line)

%000001		  NEXT_STATE = LOCKED;
		  // MEMORY action ...
%000001		  RAS_STACK_status = WRITE_RAS_STACK(DO_WRITE_STACK,in_addr);
		  // MEALY output action ...
%000001		  ras_write_active=1'b0;
%000001		  out_addr_val=1'b0;
%000001		  out_addr=ZERO_ADDR;
%000001		  empty=1'b0;
%000001		  full=1'b0;
%000001		  locked=STATE;
		end
	  end // UNLOCKED
	  endcase
	end // always_comb
	
	
	  //
	 // memory functions
	//---------------------------
 000470	function automatic [RAS_WIDTH-1:0] READ_RAS_STACK( read );
 000235	   RAS_STACK_rd = read;
 000235	   READ_RAS_STACK = RAS_STACK_rd_data;
	endfunction
	
 000462	function automatic WRITE_RAS_STACK( write, [RAS_WIDTH-1:0] write_data);
 000231	   RAS_STACK_wr = write;
 000231	   RAS_STACK_wr_data = write_data;
 000231	   WRITE_RAS_STACK = write;
	endfunction
	
	endmodule
	
	
	  //
	 // memory
	//---------------------------
	module STACK ( clk, res_n, wr, wr_data, rd, rd_data, empty, full );
	
	parameter data_width = 32;
	parameter num_of_entries = 16;
	parameter addr_width = $clog2(num_of_entries);
	
 000200	input  logic clk, res_n, rd, wr;
%000003	verilator_coverage: (next point on previous line)

 000028	verilator_coverage: (next point on previous line)

 000037	verilator_coverage: (next point on previous line)

 000134	input  logic [data_width-1:0] wr_data;
 000861	output logic [data_width-1:0] rd_data;
%000003	output logic empty, full;
%000000	verilator_coverage: (next point on previous line)

	    
	parameter ZERO_ADDR = {addr_width{1'b0}};
	parameter ZERO_DATA = {data_width{1'b0}};
	
	logic [data_width-1:0] MEMORY [num_of_entries-1:0];
 000039	logic [addr_width-1:0]   HEAD, HEAD_PLUS_1, HEAD_MINUS_1; 
 000043	verilator_coverage: (next point on previous line)

 000047	verilator_coverage: (next point on previous line)

	
	integer i;
	
%000002	initial begin
%000001	    for ( i = 0; i < num_of_entries; i = i + 1 ) begin
 000032	    verilator_coverage: (next point on previous line)

 000016	        MEMORY[ i ] = ZERO_DATA;
	    end
%000001	    HEAD = ZERO_ADDR;
	end
	
	// IN-CYCLE READ ACCESS
	assign rd_data = ( rd && res_n ) ? MEMORY[HEAD] : ZERO_DATA;
	assign empty = (HEAD=={addr_width{1'b0}});
	assign full = (HEAD=={addr_width{1'b1}});
	assign HEAD_PLUS_1 = HEAD + 1'b1;
	assign HEAD_MINUS_1 = HEAD - 1'b1;
	
 000200	always @ ( negedge clk ) begin
 000194	  if( res_n ) begin
%000003	  verilator_coverage: (next point on previous line)

 000022	    if( rd & !wr &&  !empty ) HEAD <= HEAD_MINUS_1; // READ ACCESS
 000086	    verilator_coverage: (next point on previous line)

 000036	    if( wr & ( !full | rd )) begin // WRITE ACCESS
 000079	    verilator_coverage: (next point on previous line)

%000014	      if( rd ) begin
 000011	      verilator_coverage: (next point on previous line)

%000007	        MEMORY[HEAD] <= wr_data;
 000011	      end else begin
 000011	        MEMORY[HEAD_PLUS_1] <= wr_data;
 000011	        HEAD <= HEAD_PLUS_1;
	      end
	    end
%000003	  end else begin
%000003	    MEMORY[ZERO_ADDR] <= ZERO_DATA;
%000003	    HEAD <= ZERO_ADDR;
	  end
	end
	
	endmodule
	
