// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See VRAS.h for the primary calling header

#include "VRAS.h"
#include "VRAS__Syms.h"

//==========

void VRAS::eval_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+++++TOP Evaluate VRAS::eval\n"); );
    VRAS__Syms* __restrict vlSymsp = this->__VlSymsp;  // Setup global symbol table
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
#ifdef VL_DEBUG
    // Debug assertions
    _eval_debug_assertions();
#endif  // VL_DEBUG
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    int __VclockLoop = 0;
    QData __Vchange = 1;
    do {
        VL_DEBUG_IF(VL_DBG_MSGF("+ Clock loop\n"););
        vlSymsp->__Vm_activity = true;
        _eval(vlSymsp);
        if (VL_UNLIKELY(++__VclockLoop > 100)) {
            // About to fail, so enable debug to see what's not settling.
            // Note you must run make with OPT=-DVL_DEBUG for debug prints.
            int __Vsaved_debug = Verilated::debug();
            Verilated::debug(1);
            __Vchange = _change_request(vlSymsp);
            Verilated::debug(__Vsaved_debug);
            VL_FATAL_MT("RAS.sv", 11, "",
                "Verilated model didn't converge\n"
                "- See DIDNOTCONVERGE in the Verilator manual");
        } else {
            __Vchange = _change_request(vlSymsp);
        }
    } while (VL_UNLIKELY(__Vchange));
}

void VRAS::eval_end_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+eval_end_step VRAS::eval_end_step\n"); );
#ifdef VM_TRACE
    VRAS__Syms* __restrict vlSymsp = this->__VlSymsp;  // Setup global symbol table
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Tracing
    if (VL_UNLIKELY(vlSymsp->__Vm_dumping)) _traceDump();
#endif  // VM_TRACE
}

void VRAS::_eval_initial_loop(VRAS__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    // Evaluate till stable
    int __VclockLoop = 0;
    QData __Vchange = 1;
    do {
        _eval_settle(vlSymsp);
        _eval(vlSymsp);
        if (VL_UNLIKELY(++__VclockLoop > 100)) {
            // About to fail, so enable debug to see what's not settling.
            // Note you must run make with OPT=-DVL_DEBUG for debug prints.
            int __Vsaved_debug = Verilated::debug();
            Verilated::debug(1);
            __Vchange = _change_request(vlSymsp);
            Verilated::debug(__Vsaved_debug);
            VL_FATAL_MT("RAS.sv", 11, "",
                "Verilated model didn't DC converge\n"
                "- See DIDNOTCONVERGE in the Verilator manual");
        } else {
            __Vchange = _change_request(vlSymsp);
        }
    } while (VL_UNLIKELY(__Vchange));
}

VL_INLINE_OPT void VRAS::_combo__TOP__1(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_combo__TOP__1\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    if ((1U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK_rd_data) 
               ^ (IData)(vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data)))) {
        ++(vlSymsp->__Vcoverage[192]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffffeULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | (IData)((IData)((1U & (IData)(vlTOPp->RAS__DOT__RAS_STACK_rd_data)))));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 1U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 1U))))) {
        ++(vlSymsp->__Vcoverage[193]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffffdULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 1U))))) 
                  << 1U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 2U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 2U))))) {
        ++(vlSymsp->__Vcoverage[194]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffffbULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 2U))))) 
                  << 2U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 3U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 3U))))) {
        ++(vlSymsp->__Vcoverage[195]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffff7ULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 3U))))) 
                  << 3U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 4U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 4U))))) {
        ++(vlSymsp->__Vcoverage[196]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffffefULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 4U))))) 
                  << 4U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 5U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 5U))))) {
        ++(vlSymsp->__Vcoverage[197]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffffdfULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 5U))))) 
                  << 5U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 6U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 6U))))) {
        ++(vlSymsp->__Vcoverage[198]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffffbfULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 6U))))) 
                  << 6U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 7U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 7U))))) {
        ++(vlSymsp->__Vcoverage[199]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffff7fULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 7U))))) 
                  << 7U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 8U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 8U))))) {
        ++(vlSymsp->__Vcoverage[200]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffeffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 8U))))) 
                  << 8U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 9U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                           >> 9U))))) {
        ++(vlSymsp->__Vcoverage[201]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffdffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 9U))))) 
                  << 9U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0xaU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                             >> 0xaU))))) {
        ++(vlSymsp->__Vcoverage[202]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffffbffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0xaU))))) 
                  << 0xaU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0xbU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                             >> 0xbU))))) {
        ++(vlSymsp->__Vcoverage[203]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffff7ffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0xbU))))) 
                  << 0xbU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0xcU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                             >> 0xcU))))) {
        ++(vlSymsp->__Vcoverage[204]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffefffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0xcU))))) 
                  << 0xcU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0xdU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                             >> 0xdU))))) {
        ++(vlSymsp->__Vcoverage[205]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffdfffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0xdU))))) 
                  << 0xdU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0xeU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                             >> 0xeU))))) {
        ++(vlSymsp->__Vcoverage[206]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffffbfffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0xeU))))) 
                  << 0xeU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0xfU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                             >> 0xfU))))) {
        ++(vlSymsp->__Vcoverage[207]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffff7fffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0xfU))))) 
                  << 0xfU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x10U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x10U))))) {
        ++(vlSymsp->__Vcoverage[208]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffeffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x10U))))) 
                  << 0x10U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x11U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x11U))))) {
        ++(vlSymsp->__Vcoverage[209]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffdffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x11U))))) 
                  << 0x11U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x12U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x12U))))) {
        ++(vlSymsp->__Vcoverage[210]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffffbffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x12U))))) 
                  << 0x12U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x13U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x13U))))) {
        ++(vlSymsp->__Vcoverage[211]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffff7ffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x13U))))) 
                  << 0x13U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x14U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x14U))))) {
        ++(vlSymsp->__Vcoverage[212]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffefffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x14U))))) 
                  << 0x14U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x15U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x15U))))) {
        ++(vlSymsp->__Vcoverage[213]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffdfffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x15U))))) 
                  << 0x15U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x16U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x16U))))) {
        ++(vlSymsp->__Vcoverage[214]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffffbfffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x16U))))) 
                  << 0x16U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x17U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x17U))))) {
        ++(vlSymsp->__Vcoverage[215]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffff7fffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x17U))))) 
                  << 0x17U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x18U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x18U))))) {
        ++(vlSymsp->__Vcoverage[216]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffeffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x18U))))) 
                  << 0x18U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x19U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x19U))))) {
        ++(vlSymsp->__Vcoverage[217]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffdffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x19U))))) 
                  << 0x19U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x1aU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x1aU))))) {
        ++(vlSymsp->__Vcoverage[218]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffffbffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x1aU))))) 
                  << 0x1aU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x1bU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x1bU))))) {
        ++(vlSymsp->__Vcoverage[219]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffff7ffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x1bU))))) 
                  << 0x1bU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x1cU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x1cU))))) {
        ++(vlSymsp->__Vcoverage[220]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffefffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x1cU))))) 
                  << 0x1cU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x1dU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x1dU))))) {
        ++(vlSymsp->__Vcoverage[221]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffdfffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x1dU))))) 
                  << 0x1dU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x1eU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x1eU))))) {
        ++(vlSymsp->__Vcoverage[222]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffffbfffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x1eU))))) 
                  << 0x1eU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x1fU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x1fU))))) {
        ++(vlSymsp->__Vcoverage[223]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffff7fffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x1fU))))) 
                  << 0x1fU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x20U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x20U))))) {
        ++(vlSymsp->__Vcoverage[224]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffeffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x20U))))) 
                  << 0x20U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x21U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x21U))))) {
        ++(vlSymsp->__Vcoverage[225]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffdffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x21U))))) 
                  << 0x21U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x22U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x22U))))) {
        ++(vlSymsp->__Vcoverage[226]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfffbffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x22U))))) 
                  << 0x22U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x23U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x23U))))) {
        ++(vlSymsp->__Vcoverage[227]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfff7ffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x23U))))) 
                  << 0x23U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x24U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x24U))))) {
        ++(vlSymsp->__Vcoverage[228]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffefffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x24U))))) 
                  << 0x24U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x25U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x25U))))) {
        ++(vlSymsp->__Vcoverage[229]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffdfffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x25U))))) 
                  << 0x25U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x26U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x26U))))) {
        ++(vlSymsp->__Vcoverage[230]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xffbfffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x26U))))) 
                  << 0x26U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x27U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x27U))))) {
        ++(vlSymsp->__Vcoverage[231]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xff7fffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x27U))))) 
                  << 0x27U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x28U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x28U))))) {
        ++(vlSymsp->__Vcoverage[232]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfeffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x28U))))) 
                  << 0x28U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x29U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x29U))))) {
        ++(vlSymsp->__Vcoverage[233]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfdffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x29U))))) 
                  << 0x29U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x2aU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x2aU))))) {
        ++(vlSymsp->__Vcoverage[234]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xfbffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x2aU))))) 
                  << 0x2aU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x2bU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x2bU))))) {
        ++(vlSymsp->__Vcoverage[235]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xf7ffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x2bU))))) 
                  << 0x2bU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x2cU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x2cU))))) {
        ++(vlSymsp->__Vcoverage[236]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xefffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x2cU))))) 
                  << 0x2cU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x2dU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x2dU))))) {
        ++(vlSymsp->__Vcoverage[237]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xdfffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x2dU))))) 
                  << 0x2dU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x2eU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x2eU))))) {
        ++(vlSymsp->__Vcoverage[238]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0xbfffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x2eU))))) 
                  << 0x2eU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                        >> 0x2fU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
                                              >> 0x2fU))))) {
        ++(vlSymsp->__Vcoverage[239]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data 
            = ((0x7fffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_rd_data 
                                                 >> 0x2fU))))) 
                  << 0x2fU));
    }
    if (((IData)(vlTOPp->clk) ^ vlTOPp->RAS__DOT____Vtogcov__clk)) {
        ++(vlSymsp->__Vcoverage[0]);
        vlTOPp->RAS__DOT____Vtogcov__clk = vlTOPp->clk;
    }
    if (((IData)(vlTOPp->res_n) ^ vlTOPp->RAS__DOT____Vtogcov__res_n)) {
        ++(vlSymsp->__Vcoverage[1]);
        vlTOPp->RAS__DOT____Vtogcov__res_n = vlTOPp->res_n;
    }
    if (((IData)(vlTOPp->lock) ^ vlTOPp->RAS__DOT____Vtogcov__lock)) {
        ++(vlSymsp->__Vcoverage[2]);
        vlTOPp->RAS__DOT____Vtogcov__lock = vlTOPp->lock;
    }
    if (((IData)(vlTOPp->unlock) ^ vlTOPp->RAS__DOT____Vtogcov__unlock)) {
        ++(vlSymsp->__Vcoverage[3]);
        vlTOPp->RAS__DOT____Vtogcov__unlock = vlTOPp->unlock;
    }
    if (((IData)(vlTOPp->in_addr_val) ^ vlTOPp->RAS__DOT____Vtogcov__in_addr_val)) {
        ++(vlSymsp->__Vcoverage[36]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr_val = vlTOPp->in_addr_val;
    }
    if (((IData)(vlTOPp->rd) ^ vlTOPp->RAS__DOT____Vtogcov__rd)) {
        ++(vlSymsp->__Vcoverage[85]);
        vlTOPp->RAS__DOT____Vtogcov__rd = vlTOPp->rd;
    }
    if (((0xdeadbeefU == vlTOPp->key) ^ vlTOPp->RAS__DOT____Vtogcov__IS_KEY_MATCH)) {
        ++(vlSymsp->__Vcoverage[247]);
        vlTOPp->RAS__DOT____Vtogcov__IS_KEY_MATCH = 
            (0xdeadbeefU == vlTOPp->key);
    }
    if ((1U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[4]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffffeU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (1U & vlTOPp->key));
    }
    if ((2U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[5]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffffdU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (2U & vlTOPp->key));
    }
    if ((4U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[6]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffffbU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (4U & vlTOPp->key));
    }
    if ((8U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[7]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffff7U 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (8U & vlTOPp->key));
    }
    if ((0x10U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[8]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffffefU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x10U 
                                               & vlTOPp->key));
    }
    if ((0x20U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[9]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffffdfU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x20U 
                                               & vlTOPp->key));
    }
    if ((0x40U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[10]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffffbfU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x40U 
                                               & vlTOPp->key));
    }
    if ((0x80U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[11]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffff7fU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x80U 
                                               & vlTOPp->key));
    }
    if ((0x100U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[12]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffeffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x100U 
                                               & vlTOPp->key));
    }
    if ((0x200U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[13]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffdffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x200U 
                                               & vlTOPp->key));
    }
    if ((0x400U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[14]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffffbffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x400U 
                                               & vlTOPp->key));
    }
    if ((0x800U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[15]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffff7ffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x800U 
                                               & vlTOPp->key));
    }
    if ((0x1000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[16]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffefffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x1000U 
                                               & vlTOPp->key));
    }
    if ((0x2000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[17]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffdfffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x2000U 
                                               & vlTOPp->key));
    }
    if ((0x4000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[18]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffffbfffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x4000U 
                                               & vlTOPp->key));
    }
    if ((0x8000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[19]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffff7fffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x8000U 
                                               & vlTOPp->key));
    }
    if ((0x10000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[20]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffeffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x10000U 
                                               & vlTOPp->key));
    }
    if ((0x20000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[21]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffdffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x20000U 
                                               & vlTOPp->key));
    }
    if ((0x40000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[22]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfffbffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x40000U 
                                               & vlTOPp->key));
    }
    if ((0x80000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[23]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfff7ffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x80000U 
                                               & vlTOPp->key));
    }
    if ((0x100000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[24]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffefffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x100000U 
                                               & vlTOPp->key));
    }
    if ((0x200000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[25]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffdfffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x200000U 
                                               & vlTOPp->key));
    }
    if ((0x400000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[26]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xffbfffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x400000U 
                                               & vlTOPp->key));
    }
    if ((0x800000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[27]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xff7fffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x800000U 
                                               & vlTOPp->key));
    }
    if ((0x1000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[28]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfeffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x1000000U 
                                               & vlTOPp->key));
    }
    if ((0x2000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[29]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfdffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x2000000U 
                                               & vlTOPp->key));
    }
    if ((0x4000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[30]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xfbffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x4000000U 
                                               & vlTOPp->key));
    }
    if ((0x8000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[31]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xf7ffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x8000000U 
                                               & vlTOPp->key));
    }
    if ((0x10000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[32]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xefffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x10000000U 
                                               & vlTOPp->key));
    }
    if ((0x20000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[33]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xdfffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x20000000U 
                                               & vlTOPp->key));
    }
    if ((0x40000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[34]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0xbfffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x40000000U 
                                               & vlTOPp->key));
    }
    if ((0x80000000U & (vlTOPp->key ^ vlTOPp->RAS__DOT____Vtogcov__key))) {
        ++(vlSymsp->__Vcoverage[35]);
        vlTOPp->RAS__DOT____Vtogcov__key = ((0x7fffffffU 
                                             & vlTOPp->RAS__DOT____Vtogcov__key) 
                                            | (0x80000000U 
                                               & vlTOPp->key));
    }
    if ((1U & ((IData)(vlTOPp->in_addr) ^ (IData)(vlTOPp->RAS__DOT____Vtogcov__in_addr)))) {
        ++(vlSymsp->__Vcoverage[37]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffffeULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | (IData)((IData)(
                                                                  (1U 
                                                                   & (IData)(vlTOPp->in_addr)))));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 1U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 1U))))) {
        ++(vlSymsp->__Vcoverage[38]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffffdULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 1U))))) 
                                                   << 1U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 2U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 2U))))) {
        ++(vlSymsp->__Vcoverage[39]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffffbULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 2U))))) 
                                                   << 2U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 3U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 3U))))) {
        ++(vlSymsp->__Vcoverage[40]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffff7ULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 3U))))) 
                                                   << 3U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 4U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 4U))))) {
        ++(vlSymsp->__Vcoverage[41]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffffefULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 4U))))) 
                                                   << 4U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 5U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 5U))))) {
        ++(vlSymsp->__Vcoverage[42]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffffdfULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 5U))))) 
                                                   << 5U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 6U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 6U))))) {
        ++(vlSymsp->__Vcoverage[43]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffffbfULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 6U))))) 
                                                   << 6U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 7U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 7U))))) {
        ++(vlSymsp->__Vcoverage[44]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffff7fULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 7U))))) 
                                                   << 7U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 8U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 8U))))) {
        ++(vlSymsp->__Vcoverage[45]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffeffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 8U))))) 
                                                   << 8U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 9U)) ^ (IData)(
                                                          (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                           >> 9U))))) {
        ++(vlSymsp->__Vcoverage[46]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffdffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 9U))))) 
                                                   << 9U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0xaU)) ^ (IData)(
                                                            (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                             >> 0xaU))))) {
        ++(vlSymsp->__Vcoverage[47]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffffbffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0xaU))))) 
                                                   << 0xaU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0xbU)) ^ (IData)(
                                                            (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                             >> 0xbU))))) {
        ++(vlSymsp->__Vcoverage[48]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffff7ffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0xbU))))) 
                                                   << 0xbU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0xcU)) ^ (IData)(
                                                            (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                             >> 0xcU))))) {
        ++(vlSymsp->__Vcoverage[49]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffefffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0xcU))))) 
                                                   << 0xcU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0xdU)) ^ (IData)(
                                                            (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                             >> 0xdU))))) {
        ++(vlSymsp->__Vcoverage[50]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffdfffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0xdU))))) 
                                                   << 0xdU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0xeU)) ^ (IData)(
                                                            (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                             >> 0xeU))))) {
        ++(vlSymsp->__Vcoverage[51]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffffbfffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0xeU))))) 
                                                   << 0xeU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0xfU)) ^ (IData)(
                                                            (vlTOPp->RAS__DOT____Vtogcov__in_addr 
                                                             >> 0xfU))))) {
        ++(vlSymsp->__Vcoverage[52]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffff7fffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0xfU))))) 
                                                   << 0xfU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x10U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x10U))))) {
        ++(vlSymsp->__Vcoverage[53]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffeffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x10U))))) 
                                                   << 0x10U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x11U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x11U))))) {
        ++(vlSymsp->__Vcoverage[54]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffdffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x11U))))) 
                                                   << 0x11U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x12U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x12U))))) {
        ++(vlSymsp->__Vcoverage[55]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffffbffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x12U))))) 
                                                   << 0x12U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x13U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x13U))))) {
        ++(vlSymsp->__Vcoverage[56]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffff7ffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x13U))))) 
                                                   << 0x13U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x14U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x14U))))) {
        ++(vlSymsp->__Vcoverage[57]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffefffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x14U))))) 
                                                   << 0x14U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x15U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x15U))))) {
        ++(vlSymsp->__Vcoverage[58]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffdfffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x15U))))) 
                                                   << 0x15U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x16U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x16U))))) {
        ++(vlSymsp->__Vcoverage[59]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffffbfffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x16U))))) 
                                                   << 0x16U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x17U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x17U))))) {
        ++(vlSymsp->__Vcoverage[60]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffff7fffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x17U))))) 
                                                   << 0x17U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x18U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x18U))))) {
        ++(vlSymsp->__Vcoverage[61]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffeffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x18U))))) 
                                                   << 0x18U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x19U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x19U))))) {
        ++(vlSymsp->__Vcoverage[62]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffdffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x19U))))) 
                                                   << 0x19U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x1aU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x1aU))))) {
        ++(vlSymsp->__Vcoverage[63]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffffbffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x1aU))))) 
                                                   << 0x1aU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x1bU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x1bU))))) {
        ++(vlSymsp->__Vcoverage[64]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffff7ffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x1bU))))) 
                                                   << 0x1bU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x1cU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x1cU))))) {
        ++(vlSymsp->__Vcoverage[65]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffefffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x1cU))))) 
                                                   << 0x1cU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x1dU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x1dU))))) {
        ++(vlSymsp->__Vcoverage[66]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffdfffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x1dU))))) 
                                                   << 0x1dU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x1eU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x1eU))))) {
        ++(vlSymsp->__Vcoverage[67]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffffbfffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x1eU))))) 
                                                   << 0x1eU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x1fU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x1fU))))) {
        ++(vlSymsp->__Vcoverage[68]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffff7fffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x1fU))))) 
                                                   << 0x1fU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x20U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x20U))))) {
        ++(vlSymsp->__Vcoverage[69]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffeffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x20U))))) 
                                                   << 0x20U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x21U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x21U))))) {
        ++(vlSymsp->__Vcoverage[70]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffdffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x21U))))) 
                                                   << 0x21U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x22U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x22U))))) {
        ++(vlSymsp->__Vcoverage[71]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfffbffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x22U))))) 
                                                   << 0x22U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x23U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x23U))))) {
        ++(vlSymsp->__Vcoverage[72]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfff7ffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x23U))))) 
                                                   << 0x23U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x24U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x24U))))) {
        ++(vlSymsp->__Vcoverage[73]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffefffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x24U))))) 
                                                   << 0x24U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x25U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x25U))))) {
        ++(vlSymsp->__Vcoverage[74]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffdfffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x25U))))) 
                                                   << 0x25U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x26U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x26U))))) {
        ++(vlSymsp->__Vcoverage[75]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xffbfffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x26U))))) 
                                                   << 0x26U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x27U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x27U))))) {
        ++(vlSymsp->__Vcoverage[76]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xff7fffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x27U))))) 
                                                   << 0x27U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x28U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x28U))))) {
        ++(vlSymsp->__Vcoverage[77]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfeffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x28U))))) 
                                                   << 0x28U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x29U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x29U))))) {
        ++(vlSymsp->__Vcoverage[78]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfdffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x29U))))) 
                                                   << 0x29U));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x2aU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x2aU))))) {
        ++(vlSymsp->__Vcoverage[79]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xfbffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x2aU))))) 
                                                   << 0x2aU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x2bU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x2bU))))) {
        ++(vlSymsp->__Vcoverage[80]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xf7ffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x2bU))))) 
                                                   << 0x2bU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x2cU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x2cU))))) {
        ++(vlSymsp->__Vcoverage[81]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xefffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x2cU))))) 
                                                   << 0x2cU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x2dU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x2dU))))) {
        ++(vlSymsp->__Vcoverage[82]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xdfffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x2dU))))) 
                                                   << 0x2dU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x2eU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x2eU))))) {
        ++(vlSymsp->__Vcoverage[83]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0xbfffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x2eU))))) 
                                                   << 0x2eU));
    }
    if ((1U & ((IData)((vlTOPp->in_addr >> 0x2fU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__in_addr 
                          >> 0x2fU))))) {
        ++(vlSymsp->__Vcoverage[84]);
        vlTOPp->RAS__DOT____Vtogcov__in_addr = ((0x7fffffffffffULL 
                                                 & vlTOPp->RAS__DOT____Vtogcov__in_addr) 
                                                | ((QData)((IData)(
                                                                   (1U 
                                                                    & (IData)(
                                                                              (vlTOPp->in_addr 
                                                                               >> 0x2fU))))) 
                                                   << 0x2fU));
    }
    vlTOPp->RAS__DOT__DO_IDLE = (1U & ((~ (IData)(vlTOPp->lock)) 
                                       & (~ (IData)(vlTOPp->unlock))));
    vlTOPp->RAS__DOT__DO_LOCK = ((IData)(vlTOPp->lock) 
                                 & (~ (IData)(vlTOPp->unlock)));
    vlTOPp->RAS__DOT__DO_UNLOCK = (((~ (IData)(vlTOPp->lock)) 
                                    & (IData)(vlTOPp->unlock)) 
                                   & (0xdeadbeefU == vlTOPp->key));
    if (((IData)(vlTOPp->RAS__DOT__DO_IDLE) ^ vlTOPp->RAS__DOT____Vtogcov__DO_IDLE)) {
        ++(vlSymsp->__Vcoverage[242]);
        vlTOPp->RAS__DOT____Vtogcov__DO_IDLE = vlTOPp->RAS__DOT__DO_IDLE;
    }
    if (((IData)(vlTOPp->RAS__DOT__DO_LOCK) ^ vlTOPp->RAS__DOT____Vtogcov__DO_LOCK)) {
        ++(vlSymsp->__Vcoverage[243]);
        vlTOPp->RAS__DOT____Vtogcov__DO_LOCK = vlTOPp->RAS__DOT__DO_LOCK;
    }
    if (((IData)(vlTOPp->RAS__DOT__DO_UNLOCK) ^ vlTOPp->RAS__DOT____Vtogcov__DO_UNLOCK)) {
        ++(vlSymsp->__Vcoverage[245]);
        vlTOPp->RAS__DOT____Vtogcov__DO_UNLOCK = vlTOPp->RAS__DOT__DO_UNLOCK;
    }
}

VL_INLINE_OPT void VRAS::_sequent__TOP__3(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_sequent__TOP__3\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    ++(vlSymsp->__Vcoverage[255]);
    if (VL_UNLIKELY(((((IData)(vlTOPp->lock) & (IData)(vlTOPp->unlock)) 
                      & (IData)(vlTOPp->in_addr_val)) 
                     & (~ (IData)(vlTOPp->res_n))))) {
        VL_WRITEF("*-* All Finished *-*\n");
        ++(vlSymsp->__Vcoverage[253]);
        VL_FINISH_MT("RAS.sv", 116, "");
    } else {
        ++(vlSymsp->__Vcoverage[254]);
    }
    if (vlTOPp->res_n) {
        ++(vlSymsp->__Vcoverage[251]);
        vlTOPp->RAS__DOT__STATE = vlTOPp->RAS__DOT__NEXT_STATE;
    } else {
        ++(vlSymsp->__Vcoverage[252]);
        vlTOPp->RAS__DOT__STATE = 1U;
    }
    if (((IData)(vlTOPp->RAS__DOT__STATE) ^ vlTOPp->RAS__DOT____Vtogcov__STATE)) {
        ++(vlSymsp->__Vcoverage[139]);
        vlTOPp->RAS__DOT____Vtogcov__STATE = vlTOPp->RAS__DOT__STATE;
    }
}

VL_INLINE_OPT void VRAS::_sequent__TOP__4(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_sequent__TOP__4\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Variables
    CData/*3:0*/ __Vdly__RAS__DOT__RAS_STACK__DOT__HEAD;
    CData/*3:0*/ __Vdlyvdim0__RAS__DOT__RAS_STACK__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v0;
    CData/*3:0*/ __Vdlyvdim0__RAS__DOT__RAS_STACK__DOT__MEMORY__v1;
    CData/*0:0*/ __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v1;
    CData/*0:0*/ __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v2;
    QData/*47:0*/ __Vdlyvval__RAS__DOT__RAS_STACK__DOT__MEMORY__v0;
    QData/*47:0*/ __Vdlyvval__RAS__DOT__RAS_STACK__DOT__MEMORY__v1;
    // Body
    __Vdly__RAS__DOT__RAS_STACK__DOT__HEAD = vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD;
    __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v0 = 0U;
    __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v1 = 0U;
    __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v2 = 0U;
    ++(vlSymsp->__Vcoverage[291]);
    if (vlTOPp->res_n) {
        ++(vlSymsp->__Vcoverage[289]);
        if ((((IData)(vlTOPp->RAS__DOT__RAS_STACK_rd) 
              & (~ (IData)(vlTOPp->RAS__DOT__RAS_STACK_wr))) 
             & (~ (IData)(vlTOPp->RAS__DOT__RAS_STACK_empty)))) {
            ++(vlSymsp->__Vcoverage[283]);
            __Vdly__RAS__DOT__RAS_STACK__DOT__HEAD 
                = vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD_MINUS_1;
        } else {
            ++(vlSymsp->__Vcoverage[284]);
        }
        if (((IData)(vlTOPp->RAS__DOT__RAS_STACK_wr) 
             & ((~ (IData)(vlTOPp->RAS__DOT__RAS_STACK_full)) 
                | (IData)(vlTOPp->RAS__DOT__RAS_STACK_rd)))) {
            ++(vlSymsp->__Vcoverage[287]);
            if (vlTOPp->RAS__DOT__RAS_STACK_rd) {
                ++(vlSymsp->__Vcoverage[285]);
                __Vdlyvval__RAS__DOT__RAS_STACK__DOT__MEMORY__v0 
                    = vlTOPp->RAS__DOT__RAS_STACK_wr_data;
                __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v0 = 1U;
                __Vdlyvdim0__RAS__DOT__RAS_STACK__DOT__MEMORY__v0 
                    = vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD;
            } else {
                ++(vlSymsp->__Vcoverage[286]);
                __Vdlyvval__RAS__DOT__RAS_STACK__DOT__MEMORY__v1 
                    = vlTOPp->RAS__DOT__RAS_STACK_wr_data;
                __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v1 = 1U;
                __Vdlyvdim0__RAS__DOT__RAS_STACK__DOT__MEMORY__v1 
                    = vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD_PLUS_1;
                __Vdly__RAS__DOT__RAS_STACK__DOT__HEAD 
                    = vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD_PLUS_1;
            }
        } else {
            ++(vlSymsp->__Vcoverage[288]);
        }
    } else {
        ++(vlSymsp->__Vcoverage[290]);
        __Vdly__RAS__DOT__RAS_STACK__DOT__HEAD = 0U;
        __Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v2 = 1U;
    }
    if (__Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v0) {
        vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[__Vdlyvdim0__RAS__DOT__RAS_STACK__DOT__MEMORY__v0] 
            = __Vdlyvval__RAS__DOT__RAS_STACK__DOT__MEMORY__v0;
    }
    if (__Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v1) {
        vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[__Vdlyvdim0__RAS__DOT__RAS_STACK__DOT__MEMORY__v1] 
            = __Vdlyvval__RAS__DOT__RAS_STACK__DOT__MEMORY__v1;
    }
    if (__Vdlyvset__RAS__DOT__RAS_STACK__DOT__MEMORY__v2) {
        vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[0U] = 0ULL;
    }
    vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD = __Vdly__RAS__DOT__RAS_STACK__DOT__HEAD;
    if (((0U == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)) 
         ^ vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_empty)) {
        ++(vlSymsp->__Vcoverage[240]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_empty 
            = (0U == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
    }
    if (((0xfU == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)) 
         ^ vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_full)) {
        ++(vlSymsp->__Vcoverage[241]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_full 
            = (0xfU == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
    }
    vlTOPp->RAS__DOT__RAS_STACK_empty = (0U == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
    vlTOPp->RAS__DOT__RAS_STACK_full = (0xfU == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
    vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD_PLUS_1 = 
        (0xfU & ((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)));
    vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD_MINUS_1 
        = (0xfU & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                   - (IData)(1U)));
    if ((1U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
               ^ vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[269]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD 
            = ((0xeU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD)) 
               | (1U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)));
    }
    if ((2U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
               ^ vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[270]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD 
            = ((0xdU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD)) 
               | (2U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)));
    }
    if ((4U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
               ^ vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[271]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD 
            = ((0xbU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD)) 
               | (4U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)));
    }
    if ((8U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
               ^ vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD))) {
        ++(vlSymsp->__Vcoverage[272]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD 
            = ((7U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD)) 
               | (8U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)));
    }
    if ((1U & (((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)) 
               ^ vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1))) {
        ++(vlSymsp->__Vcoverage[273]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
            = ((0xeU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1)) 
               | (1U & ((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD))));
    }
    if ((1U & ((7U & (((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)) 
                      >> 1U)) ^ (vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
                                 >> 1U)))) {
        ++(vlSymsp->__Vcoverage[274]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
            = ((0xdU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1)) 
               | (2U & ((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD))));
    }
    if ((1U & ((3U & (((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)) 
                      >> 2U)) ^ (vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
                                 >> 2U)))) {
        ++(vlSymsp->__Vcoverage[275]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
            = ((0xbU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1)) 
               | (4U & ((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD))));
    }
    if ((1U & ((1U & (((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)) 
                      >> 3U)) ^ (vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
                                 >> 3U)))) {
        ++(vlSymsp->__Vcoverage[276]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1 
            = ((7U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_PLUS_1)) 
               | (8U & ((IData)(1U) + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD))));
    }
    if ((1U & (((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                - (IData)(1U)) ^ vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1))) {
        ++(vlSymsp->__Vcoverage[277]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
            = ((0xeU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1)) 
               | (1U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                        - (IData)(1U))));
    }
    if ((1U & ((7U & (((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                       - (IData)(1U)) >> 1U)) ^ (vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
                                                 >> 1U)))) {
        ++(vlSymsp->__Vcoverage[278]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
            = ((0xdU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1)) 
               | (2U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                        - (IData)(1U))));
    }
    if ((1U & ((3U & (((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                       - (IData)(1U)) >> 2U)) ^ (vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
                                                 >> 2U)))) {
        ++(vlSymsp->__Vcoverage[279]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
            = ((0xbU & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1)) 
               | (4U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                        - (IData)(1U))));
    }
    if ((1U & ((1U & (((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                       - (IData)(1U)) >> 3U)) ^ (vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
                                                 >> 3U)))) {
        ++(vlSymsp->__Vcoverage[280]);
        vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1 
            = ((7U & (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT____Vtogcov__HEAD_MINUS_1)) 
               | (8U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                        - (IData)(1U))));
    }
}

VL_INLINE_OPT void VRAS::_combo__TOP__6(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_combo__TOP__6\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->RAS__DOT__DO_WRITE_STACK = ((~ (IData)(vlTOPp->RAS__DOT__STATE)) 
                                        & (IData)(vlTOPp->in_addr_val));
    vlTOPp->RAS__DOT__DO_READ_STACK = ((~ (IData)(vlTOPp->RAS__DOT__STATE)) 
                                       & (IData)(vlTOPp->rd));
    if (((IData)(vlTOPp->RAS__DOT__DO_WRITE_STACK) 
         ^ vlTOPp->RAS__DOT____Vtogcov__DO_WRITE_STACK)) {
        ++(vlSymsp->__Vcoverage[246]);
        vlTOPp->RAS__DOT____Vtogcov__DO_WRITE_STACK 
            = vlTOPp->RAS__DOT__DO_WRITE_STACK;
    }
    if (((IData)(vlTOPp->RAS__DOT__DO_READ_STACK) ^ vlTOPp->RAS__DOT____Vtogcov__DO_READ_STACK)) {
        ++(vlSymsp->__Vcoverage[244]);
        vlTOPp->RAS__DOT____Vtogcov__DO_READ_STACK 
            = vlTOPp->RAS__DOT__DO_READ_STACK;
    }
    vlTOPp->__Vfunc_RAS__DOT__READ_RAS_STACK__0__read 
        = vlTOPp->RAS__DOT__DO_READ_STACK;
    vlTOPp->__Vfunc_RAS__DOT__READ_RAS_STACK__0__Vfuncout 
        = vlTOPp->RAS__DOT__RAS_STACK_rd_data;
    ++(vlSymsp->__Vcoverage[267]);
    vlTOPp->RAS__DOT__RAS_STACK_rd = vlTOPp->__Vfunc_RAS__DOT__READ_RAS_STACK__0__read;
    vlTOPp->RAS__DOT__RAS_STACK_rd_data = vlTOPp->__Vfunc_RAS__DOT__READ_RAS_STACK__0__Vfuncout;
    ++(vlSymsp->__Vcoverage[266]);
    if (vlTOPp->RAS__DOT__STATE) {
        ++(vlSymsp->__Vcoverage[260]);
        if (vlTOPp->RAS__DOT__DO_UNLOCK) {
            ++(vlSymsp->__Vcoverage[257]);
        } else {
            vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write_data 
                = vlTOPp->in_addr;
            vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write 
                = vlTOPp->RAS__DOT__DO_WRITE_STACK;
            ++(vlSymsp->__Vcoverage[268]);
            ++(vlSymsp->__Vcoverage[256]);
            vlTOPp->RAS__DOT__NEXT_STATE = 1U;
            vlTOPp->RAS__DOT__RAS_STACK_wr = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write;
            vlTOPp->RAS__DOT__RAS_STACK_wr_data = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write_data;
            vlTOPp->ras_write_active = 0U;
            vlTOPp->out_addr_val = 0U;
            vlTOPp->out_addr = 0ULL;
            vlTOPp->empty = 0U;
            vlTOPp->full = 0U;
            vlTOPp->locked = vlTOPp->RAS__DOT__STATE;
            vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__Vfuncout 
                = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__write;
            vlTOPp->RAS__DOT__RAS_STACK_status = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__1__Vfuncout;
        }
        if (vlTOPp->RAS__DOT__DO_UNLOCK) {
            vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write_data 
                = vlTOPp->in_addr;
            vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write 
                = vlTOPp->RAS__DOT__DO_WRITE_STACK;
            ++(vlSymsp->__Vcoverage[268]);
            ++(vlSymsp->__Vcoverage[258]);
            vlTOPp->RAS__DOT__NEXT_STATE = 0U;
            vlTOPp->RAS__DOT__RAS_STACK_wr = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write;
            vlTOPp->RAS__DOT__RAS_STACK_wr_data = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write_data;
            vlTOPp->out_addr_val = vlTOPp->RAS__DOT__DO_READ_STACK;
            vlTOPp->out_addr = vlTOPp->RAS__DOT__RAS_STACK_rd_data;
            vlTOPp->empty = (0U == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
            vlTOPp->full = (0xfU == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
            vlTOPp->locked = vlTOPp->RAS__DOT__STATE;
            vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__Vfuncout 
                = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__write;
            vlTOPp->RAS__DOT__RAS_STACK_status = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__2__Vfuncout;
            vlTOPp->ras_write_active = vlTOPp->RAS__DOT__RAS_STACK_status;
        } else {
            ++(vlSymsp->__Vcoverage[259]);
        }
    } else {
        if ((1U & (~ (IData)(vlTOPp->RAS__DOT__STATE)))) {
            ++(vlSymsp->__Vcoverage[265]);
            if (vlTOPp->RAS__DOT__DO_IDLE) {
                vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write_data 
                    = vlTOPp->in_addr;
                vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write 
                    = vlTOPp->RAS__DOT__DO_WRITE_STACK;
                ++(vlSymsp->__Vcoverage[268]);
                ++(vlSymsp->__Vcoverage[261]);
                vlTOPp->RAS__DOT__NEXT_STATE = 0U;
                vlTOPp->RAS__DOT__RAS_STACK_wr = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write;
                vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                    = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write_data;
                vlTOPp->out_addr_val = vlTOPp->RAS__DOT__DO_READ_STACK;
                vlTOPp->out_addr = vlTOPp->RAS__DOT__RAS_STACK_rd_data;
                vlTOPp->empty = (0U == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
                vlTOPp->full = (0xfU == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD));
                vlTOPp->locked = vlTOPp->RAS__DOT__STATE;
                vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__Vfuncout 
                    = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__write;
                vlTOPp->RAS__DOT__RAS_STACK_status 
                    = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__3__Vfuncout;
                vlTOPp->ras_write_active = vlTOPp->RAS__DOT__RAS_STACK_status;
            } else {
                ++(vlSymsp->__Vcoverage[262]);
            }
            if (vlTOPp->RAS__DOT__DO_LOCK) {
                vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write_data 
                    = vlTOPp->in_addr;
                vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write 
                    = vlTOPp->RAS__DOT__DO_WRITE_STACK;
                ++(vlSymsp->__Vcoverage[268]);
                ++(vlSymsp->__Vcoverage[263]);
                vlTOPp->RAS__DOT__NEXT_STATE = 1U;
                vlTOPp->RAS__DOT__RAS_STACK_wr = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write;
                vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                    = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write_data;
                vlTOPp->ras_write_active = 0U;
                vlTOPp->out_addr_val = 0U;
                vlTOPp->out_addr = 0ULL;
                vlTOPp->empty = 0U;
                vlTOPp->full = 0U;
                vlTOPp->locked = vlTOPp->RAS__DOT__STATE;
                vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__Vfuncout 
                    = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__write;
                vlTOPp->RAS__DOT__RAS_STACK_status 
                    = vlTOPp->__Vfunc_RAS__DOT__WRITE_RAS_STACK__4__Vfuncout;
            } else {
                ++(vlSymsp->__Vcoverage[264]);
            }
        }
    }
    if (VL_UNLIKELY((1U & (~ VL_ONEHOT_I(((2U & ((~ (IData)(vlTOPp->RAS__DOT__STATE)) 
                                                 << 1U)) 
                                          | (IData)(vlTOPp->RAS__DOT__STATE))))))) {
        if (VL_UNLIKELY(Verilated::assertOn())) {
            VL_WRITEF("[%0t] %%Error: RAS.sv:129: Assertion failed in %NRAS: synthesis parallel_case, but multiple matches found\n",
                      64,VL_TIME_UNITED_Q(1),vlSymsp->name());
            VL_STOP_MT("RAS.sv", 129, "");
        }
    }
    if (((IData)(vlTOPp->RAS__DOT__RAS_STACK_rd) ^ vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd)) {
        ++(vlSymsp->__Vcoverage[191]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_rd = vlTOPp->RAS__DOT__RAS_STACK_rd;
    }
    vlTOPp->RAS__DOT__RAS_STACK_rd_data = (((IData)(vlTOPp->RAS__DOT__RAS_STACK_rd) 
                                            & (IData)(vlTOPp->res_n))
                                            ? vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY
                                           [vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD]
                                            : 0ULL);
    if (((IData)(vlTOPp->RAS__DOT__NEXT_STATE) ^ vlTOPp->RAS__DOT____Vtogcov__NEXT_STATE)) {
        ++(vlSymsp->__Vcoverage[140]);
        vlTOPp->RAS__DOT____Vtogcov__NEXT_STATE = vlTOPp->RAS__DOT__NEXT_STATE;
    }
    if (((IData)(vlTOPp->ras_write_active) ^ vlTOPp->RAS__DOT____Vtogcov__ras_write_active)) {
        ++(vlSymsp->__Vcoverage[136]);
        vlTOPp->RAS__DOT____Vtogcov__ras_write_active 
            = vlTOPp->ras_write_active;
    }
    if (((IData)(vlTOPp->out_addr_val) ^ vlTOPp->RAS__DOT____Vtogcov__out_addr_val)) {
        ++(vlSymsp->__Vcoverage[86]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr_val = vlTOPp->out_addr_val;
    }
    if (((IData)(vlTOPp->empty) ^ vlTOPp->RAS__DOT____Vtogcov__empty)) {
        ++(vlSymsp->__Vcoverage[137]);
        vlTOPp->RAS__DOT____Vtogcov__empty = vlTOPp->empty;
    }
    if (((IData)(vlTOPp->full) ^ vlTOPp->RAS__DOT____Vtogcov__full)) {
        ++(vlSymsp->__Vcoverage[138]);
        vlTOPp->RAS__DOT____Vtogcov__full = vlTOPp->full;
    }
    if (((IData)(vlTOPp->locked) ^ vlTOPp->RAS__DOT____Vtogcov__locked)) {
        ++(vlSymsp->__Vcoverage[135]);
        vlTOPp->RAS__DOT____Vtogcov__locked = vlTOPp->locked;
    }
    if (((IData)(vlTOPp->RAS__DOT__RAS_STACK_status) 
         ^ vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_status)) {
        ++(vlSymsp->__Vcoverage[141]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_status 
            = vlTOPp->RAS__DOT__RAS_STACK_status;
    }
    if (((IData)(vlTOPp->RAS__DOT__RAS_STACK_wr) ^ vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr)) {
        ++(vlSymsp->__Vcoverage[142]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr = vlTOPp->RAS__DOT__RAS_STACK_wr;
    }
    if ((1U & ((IData)(vlTOPp->out_addr) ^ (IData)(vlTOPp->RAS__DOT____Vtogcov__out_addr)))) {
        ++(vlSymsp->__Vcoverage[87]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffffeULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | (IData)((IData)(
                                                                   (1U 
                                                                    & (IData)(vlTOPp->out_addr)))));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 1U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 1U))))) {
        ++(vlSymsp->__Vcoverage[88]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffffdULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 1U))))) 
                                                    << 1U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 2U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 2U))))) {
        ++(vlSymsp->__Vcoverage[89]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffffbULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 2U))))) 
                                                    << 2U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 3U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 3U))))) {
        ++(vlSymsp->__Vcoverage[90]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffff7ULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 3U))))) 
                                                    << 3U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 4U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 4U))))) {
        ++(vlSymsp->__Vcoverage[91]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffffefULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 4U))))) 
                                                    << 4U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 5U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 5U))))) {
        ++(vlSymsp->__Vcoverage[92]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffffdfULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 5U))))) 
                                                    << 5U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 6U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 6U))))) {
        ++(vlSymsp->__Vcoverage[93]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffffbfULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 6U))))) 
                                                    << 6U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 7U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 7U))))) {
        ++(vlSymsp->__Vcoverage[94]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffff7fULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 7U))))) 
                                                    << 7U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 8U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 8U))))) {
        ++(vlSymsp->__Vcoverage[95]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffeffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 8U))))) 
                                                    << 8U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 9U)) ^ (IData)(
                                                           (vlTOPp->RAS__DOT____Vtogcov__out_addr 
                                                            >> 9U))))) {
        ++(vlSymsp->__Vcoverage[96]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffdffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 9U))))) 
                                                    << 9U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0xaU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0xaU))))) {
        ++(vlSymsp->__Vcoverage[97]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffffbffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0xaU))))) 
                                                    << 0xaU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0xbU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0xbU))))) {
        ++(vlSymsp->__Vcoverage[98]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffff7ffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0xbU))))) 
                                                    << 0xbU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0xcU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0xcU))))) {
        ++(vlSymsp->__Vcoverage[99]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffefffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0xcU))))) 
                                                    << 0xcU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0xdU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0xdU))))) {
        ++(vlSymsp->__Vcoverage[100]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffdfffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0xdU))))) 
                                                    << 0xdU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0xeU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0xeU))))) {
        ++(vlSymsp->__Vcoverage[101]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffffbfffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0xeU))))) 
                                                    << 0xeU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0xfU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0xfU))))) {
        ++(vlSymsp->__Vcoverage[102]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffff7fffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0xfU))))) 
                                                    << 0xfU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x10U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x10U))))) {
        ++(vlSymsp->__Vcoverage[103]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffeffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x10U))))) 
                                                    << 0x10U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x11U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x11U))))) {
        ++(vlSymsp->__Vcoverage[104]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffdffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x11U))))) 
                                                    << 0x11U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x12U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x12U))))) {
        ++(vlSymsp->__Vcoverage[105]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffffbffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x12U))))) 
                                                    << 0x12U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x13U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x13U))))) {
        ++(vlSymsp->__Vcoverage[106]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffff7ffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x13U))))) 
                                                    << 0x13U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x14U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x14U))))) {
        ++(vlSymsp->__Vcoverage[107]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffefffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x14U))))) 
                                                    << 0x14U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x15U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x15U))))) {
        ++(vlSymsp->__Vcoverage[108]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffdfffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x15U))))) 
                                                    << 0x15U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x16U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x16U))))) {
        ++(vlSymsp->__Vcoverage[109]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffffbfffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x16U))))) 
                                                    << 0x16U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x17U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x17U))))) {
        ++(vlSymsp->__Vcoverage[110]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffff7fffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x17U))))) 
                                                    << 0x17U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x18U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x18U))))) {
        ++(vlSymsp->__Vcoverage[111]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffeffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x18U))))) 
                                                    << 0x18U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x19U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x19U))))) {
        ++(vlSymsp->__Vcoverage[112]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffdffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x19U))))) 
                                                    << 0x19U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x1aU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x1aU))))) {
        ++(vlSymsp->__Vcoverage[113]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffffbffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x1aU))))) 
                                                    << 0x1aU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x1bU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x1bU))))) {
        ++(vlSymsp->__Vcoverage[114]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffff7ffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x1bU))))) 
                                                    << 0x1bU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x1cU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x1cU))))) {
        ++(vlSymsp->__Vcoverage[115]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffefffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x1cU))))) 
                                                    << 0x1cU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x1dU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x1dU))))) {
        ++(vlSymsp->__Vcoverage[116]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffdfffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x1dU))))) 
                                                    << 0x1dU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x1eU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x1eU))))) {
        ++(vlSymsp->__Vcoverage[117]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffffbfffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x1eU))))) 
                                                    << 0x1eU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x1fU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x1fU))))) {
        ++(vlSymsp->__Vcoverage[118]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffff7fffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x1fU))))) 
                                                    << 0x1fU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x20U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x20U))))) {
        ++(vlSymsp->__Vcoverage[119]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffeffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x20U))))) 
                                                    << 0x20U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x21U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x21U))))) {
        ++(vlSymsp->__Vcoverage[120]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffdffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x21U))))) 
                                                    << 0x21U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x22U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x22U))))) {
        ++(vlSymsp->__Vcoverage[121]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfffbffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x22U))))) 
                                                    << 0x22U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x23U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x23U))))) {
        ++(vlSymsp->__Vcoverage[122]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfff7ffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x23U))))) 
                                                    << 0x23U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x24U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x24U))))) {
        ++(vlSymsp->__Vcoverage[123]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffefffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x24U))))) 
                                                    << 0x24U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x25U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x25U))))) {
        ++(vlSymsp->__Vcoverage[124]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffdfffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x25U))))) 
                                                    << 0x25U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x26U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x26U))))) {
        ++(vlSymsp->__Vcoverage[125]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xffbfffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x26U))))) 
                                                    << 0x26U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x27U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x27U))))) {
        ++(vlSymsp->__Vcoverage[126]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xff7fffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x27U))))) 
                                                    << 0x27U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x28U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x28U))))) {
        ++(vlSymsp->__Vcoverage[127]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfeffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x28U))))) 
                                                    << 0x28U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x29U)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x29U))))) {
        ++(vlSymsp->__Vcoverage[128]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfdffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x29U))))) 
                                                    << 0x29U));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x2aU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x2aU))))) {
        ++(vlSymsp->__Vcoverage[129]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xfbffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x2aU))))) 
                                                    << 0x2aU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x2bU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x2bU))))) {
        ++(vlSymsp->__Vcoverage[130]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xf7ffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x2bU))))) 
                                                    << 0x2bU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x2cU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x2cU))))) {
        ++(vlSymsp->__Vcoverage[131]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xefffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x2cU))))) 
                                                    << 0x2cU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x2dU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x2dU))))) {
        ++(vlSymsp->__Vcoverage[132]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xdfffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x2dU))))) 
                                                    << 0x2dU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x2eU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x2eU))))) {
        ++(vlSymsp->__Vcoverage[133]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0xbfffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x2eU))))) 
                                                    << 0x2eU));
    }
    if ((1U & ((IData)((vlTOPp->out_addr >> 0x2fU)) 
               ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__out_addr 
                          >> 0x2fU))))) {
        ++(vlSymsp->__Vcoverage[134]);
        vlTOPp->RAS__DOT____Vtogcov__out_addr = ((0x7fffffffffffULL 
                                                  & vlTOPp->RAS__DOT____Vtogcov__out_addr) 
                                                 | ((QData)((IData)(
                                                                    (1U 
                                                                     & (IData)(
                                                                               (vlTOPp->out_addr 
                                                                                >> 0x2fU))))) 
                                                    << 0x2fU));
    }
    if ((1U & ((IData)(vlTOPp->RAS__DOT__RAS_STACK_wr_data) 
               ^ (IData)(vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data)))) {
        ++(vlSymsp->__Vcoverage[143]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffffeULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | (IData)((IData)((1U & (IData)(vlTOPp->RAS__DOT__RAS_STACK_wr_data)))));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 1U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 1U))))) {
        ++(vlSymsp->__Vcoverage[144]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffffdULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 1U))))) 
                  << 1U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 2U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 2U))))) {
        ++(vlSymsp->__Vcoverage[145]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffffbULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 2U))))) 
                  << 2U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 3U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 3U))))) {
        ++(vlSymsp->__Vcoverage[146]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffff7ULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 3U))))) 
                  << 3U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 4U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 4U))))) {
        ++(vlSymsp->__Vcoverage[147]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffffefULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 4U))))) 
                  << 4U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 5U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 5U))))) {
        ++(vlSymsp->__Vcoverage[148]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffffdfULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 5U))))) 
                  << 5U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 6U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 6U))))) {
        ++(vlSymsp->__Vcoverage[149]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffffbfULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 6U))))) 
                  << 6U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 7U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 7U))))) {
        ++(vlSymsp->__Vcoverage[150]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffff7fULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 7U))))) 
                  << 7U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 8U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 8U))))) {
        ++(vlSymsp->__Vcoverage[151]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffeffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 8U))))) 
                  << 8U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 9U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                           >> 9U))))) {
        ++(vlSymsp->__Vcoverage[152]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffdffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 9U))))) 
                  << 9U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0xaU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                             >> 0xaU))))) {
        ++(vlSymsp->__Vcoverage[153]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffffbffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0xaU))))) 
                  << 0xaU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0xbU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                             >> 0xbU))))) {
        ++(vlSymsp->__Vcoverage[154]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffff7ffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0xbU))))) 
                  << 0xbU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0xcU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                             >> 0xcU))))) {
        ++(vlSymsp->__Vcoverage[155]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffefffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0xcU))))) 
                  << 0xcU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0xdU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                             >> 0xdU))))) {
        ++(vlSymsp->__Vcoverage[156]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffdfffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0xdU))))) 
                  << 0xdU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0xeU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                             >> 0xeU))))) {
        ++(vlSymsp->__Vcoverage[157]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffffbfffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0xeU))))) 
                  << 0xeU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0xfU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                             >> 0xfU))))) {
        ++(vlSymsp->__Vcoverage[158]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffff7fffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0xfU))))) 
                  << 0xfU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x10U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x10U))))) {
        ++(vlSymsp->__Vcoverage[159]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffeffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x10U))))) 
                  << 0x10U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x11U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x11U))))) {
        ++(vlSymsp->__Vcoverage[160]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffdffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x11U))))) 
                  << 0x11U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x12U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x12U))))) {
        ++(vlSymsp->__Vcoverage[161]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffffbffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x12U))))) 
                  << 0x12U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x13U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x13U))))) {
        ++(vlSymsp->__Vcoverage[162]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffff7ffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x13U))))) 
                  << 0x13U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x14U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x14U))))) {
        ++(vlSymsp->__Vcoverage[163]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffefffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x14U))))) 
                  << 0x14U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x15U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x15U))))) {
        ++(vlSymsp->__Vcoverage[164]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffdfffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x15U))))) 
                  << 0x15U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x16U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x16U))))) {
        ++(vlSymsp->__Vcoverage[165]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffffbfffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x16U))))) 
                  << 0x16U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x17U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x17U))))) {
        ++(vlSymsp->__Vcoverage[166]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffff7fffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x17U))))) 
                  << 0x17U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x18U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x18U))))) {
        ++(vlSymsp->__Vcoverage[167]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffeffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x18U))))) 
                  << 0x18U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x19U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x19U))))) {
        ++(vlSymsp->__Vcoverage[168]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffdffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x19U))))) 
                  << 0x19U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x1aU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x1aU))))) {
        ++(vlSymsp->__Vcoverage[169]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffffbffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x1aU))))) 
                  << 0x1aU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x1bU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x1bU))))) {
        ++(vlSymsp->__Vcoverage[170]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffff7ffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x1bU))))) 
                  << 0x1bU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x1cU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x1cU))))) {
        ++(vlSymsp->__Vcoverage[171]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffefffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x1cU))))) 
                  << 0x1cU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x1dU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x1dU))))) {
        ++(vlSymsp->__Vcoverage[172]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffdfffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x1dU))))) 
                  << 0x1dU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x1eU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x1eU))))) {
        ++(vlSymsp->__Vcoverage[173]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffffbfffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x1eU))))) 
                  << 0x1eU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x1fU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x1fU))))) {
        ++(vlSymsp->__Vcoverage[174]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffff7fffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x1fU))))) 
                  << 0x1fU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x20U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x20U))))) {
        ++(vlSymsp->__Vcoverage[175]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffeffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x20U))))) 
                  << 0x20U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x21U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x21U))))) {
        ++(vlSymsp->__Vcoverage[176]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffdffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x21U))))) 
                  << 0x21U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x22U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x22U))))) {
        ++(vlSymsp->__Vcoverage[177]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfffbffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x22U))))) 
                  << 0x22U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x23U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x23U))))) {
        ++(vlSymsp->__Vcoverage[178]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfff7ffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x23U))))) 
                  << 0x23U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x24U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x24U))))) {
        ++(vlSymsp->__Vcoverage[179]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffefffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x24U))))) 
                  << 0x24U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x25U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x25U))))) {
        ++(vlSymsp->__Vcoverage[180]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffdfffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x25U))))) 
                  << 0x25U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x26U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x26U))))) {
        ++(vlSymsp->__Vcoverage[181]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xffbfffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x26U))))) 
                  << 0x26U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x27U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x27U))))) {
        ++(vlSymsp->__Vcoverage[182]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xff7fffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x27U))))) 
                  << 0x27U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x28U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x28U))))) {
        ++(vlSymsp->__Vcoverage[183]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfeffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x28U))))) 
                  << 0x28U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x29U)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x29U))))) {
        ++(vlSymsp->__Vcoverage[184]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfdffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x29U))))) 
                  << 0x29U));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x2aU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x2aU))))) {
        ++(vlSymsp->__Vcoverage[185]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xfbffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x2aU))))) 
                  << 0x2aU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x2bU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x2bU))))) {
        ++(vlSymsp->__Vcoverage[186]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xf7ffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x2bU))))) 
                  << 0x2bU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x2cU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x2cU))))) {
        ++(vlSymsp->__Vcoverage[187]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xefffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x2cU))))) 
                  << 0x2cU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x2dU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x2dU))))) {
        ++(vlSymsp->__Vcoverage[188]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xdfffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x2dU))))) 
                  << 0x2dU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x2eU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x2eU))))) {
        ++(vlSymsp->__Vcoverage[189]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0xbfffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x2eU))))) 
                  << 0x2eU));
    }
    if ((1U & ((IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                        >> 0x2fU)) ^ (IData)((vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
                                              >> 0x2fU))))) {
        ++(vlSymsp->__Vcoverage[190]);
        vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data 
            = ((0x7fffffffffffULL & vlTOPp->RAS__DOT____Vtogcov__RAS_STACK_wr_data) 
               | ((QData)((IData)((1U & (IData)((vlTOPp->RAS__DOT__RAS_STACK_wr_data 
                                                 >> 0x2fU))))) 
                  << 0x2fU));
    }
}

void VRAS::_eval(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_eval\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_combo__TOP__1(vlSymsp);
    vlTOPp->__Vm_traceActivity[1U] = 1U;
    if (((IData)(vlTOPp->clk) & (~ (IData)(vlTOPp->__Vclklast__TOP__clk)))) {
        vlTOPp->_sequent__TOP__3(vlSymsp);
    }
    if (((~ (IData)(vlTOPp->clk)) & (IData)(vlTOPp->__Vclklast__TOP__clk))) {
        vlTOPp->_sequent__TOP__4(vlSymsp);
        vlTOPp->__Vm_traceActivity[2U] = 1U;
    }
    vlTOPp->_combo__TOP__6(vlSymsp);
    // Final
    vlTOPp->__Vclklast__TOP__clk = vlTOPp->clk;
}

VL_INLINE_OPT QData VRAS::_change_request(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_change_request\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    return (vlTOPp->_change_request_1(vlSymsp));
}

VL_INLINE_OPT QData VRAS::_change_request_1(VRAS__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_change_request_1\n"); );
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    QData __req = false;  // Logically a bool
    __req |= ((vlTOPp->RAS__DOT__RAS_STACK_rd_data ^ vlTOPp->__Vchglast__TOP__RAS__DOT__RAS_STACK_rd_data));
    VL_DEBUG_IF( if(__req && ((vlTOPp->RAS__DOT__RAS_STACK_rd_data ^ vlTOPp->__Vchglast__TOP__RAS__DOT__RAS_STACK_rd_data))) VL_DBG_MSGF("        CHANGE: RAS.sv:59: RAS.RAS_STACK_rd_data\n"); );
    // Final
    vlTOPp->__Vchglast__TOP__RAS__DOT__RAS_STACK_rd_data 
        = vlTOPp->RAS__DOT__RAS_STACK_rd_data;
    return __req;
}

#ifdef VL_DEBUG
void VRAS::_eval_debug_assertions() {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VRAS::_eval_debug_assertions\n"); );
    // Body
    if (VL_UNLIKELY((clk & 0xfeU))) {
        Verilated::overWidthError("clk");}
    if (VL_UNLIKELY((res_n & 0xfeU))) {
        Verilated::overWidthError("res_n");}
    if (VL_UNLIKELY((lock & 0xfeU))) {
        Verilated::overWidthError("lock");}
    if (VL_UNLIKELY((unlock & 0xfeU))) {
        Verilated::overWidthError("unlock");}
    if (VL_UNLIKELY((in_addr_val & 0xfeU))) {
        Verilated::overWidthError("in_addr_val");}
    if (VL_UNLIKELY((in_addr & 0ULL))) {
        Verilated::overWidthError("in_addr");}
    if (VL_UNLIKELY((rd & 0xfeU))) {
        Verilated::overWidthError("rd");}
}
#endif  // VL_DEBUG
